From f3b89fb23a9b97d10b76f974971f720bbf56583f Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 27 2020 20:32:30 +0000
Subject: [PATCH 1582/2232] Preserve span of fields in derived Clone impl


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 5bac706..4e59aad 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -163,8 +163,14 @@ fn expand_struct(strct: &Struct) -> TokenStream {
                     quote!(*self)
                 } else {
                     let fields = strct.fields.iter().map(|field| &field.ident);
-                    quote!(#ident {
-                        #(#fields: ::std::clone::Clone::clone(&self.#fields),)*
+                    let values = strct.fields.iter().map(|field| {
+                        let ident = &field.ident;
+                        let ty = field.ty.to_token_stream();
+                        let span = ty.into_iter().last().unwrap().span();
+                        quote_spanned!(span=> &self.#ident)
+                    });
+                    quote_spanned!(derive.span=> #ident {
+                        #(#fields: ::std::clone::Clone::clone(#values),)*
                     })
                 };
                 expanded.extend(quote_spanned! {derive.span=>
diff --git a/tests/ui/derive_nonclone.stderr b/tests/ui/derive_nonclone.stderr
index f72c1e2..04eae4f 100644
--- a/tests/ui/derive_nonclone.stderr
+++ b/tests/ui/derive_nonclone.stderr
@@ -1,8 +1,7 @@
 error[E0277]: the trait bound `ffi::Other: Clone` is not satisfied
- --> $DIR/derive_nonclone.rs:1:1
+ --> $DIR/derive_nonclone.rs:5:9
   |
-1 | #[cxx::bridge]
-  | ^^^^^^^^^^^^^^ the trait `Clone` is not implemented for `ffi::Other`
+5 |         other: Other,
+  |         ^^^^^^^^^^^^ the trait `Clone` is not implemented for `ffi::Other`
   |
   = note: required by `clone`
-  = note: this error originates in an attribute macro (in Nightly builds, run with -Z macro-backtrace for more info)

